/*
******************************************************************************
File:     main.c
Info:     Generated by Atollic TrueSTUDIO(R) 9.3.0   2019-10-08

The MIT License (MIT)
Copyright (c) 2019 STMicroelectronics

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

******************************************************************************
*/

/* Includes */
#include "stm32l4xx.h"
#include <stdio.h>
#include "funciones.h"
/* Private macro */
/* Private variables */
volatile unsigned int *DWT_CYCCNT  ;
volatile unsigned int *DWT_CONTROL ;
volatile unsigned int *SCB_DEMCR   ;

/* Private function prototypes */
/* Private functions */
void reset_timer(){
    DWT_CYCCNT   = (unsigned int *)0xE0001004; //address of the register
    DWT_CONTROL  = (unsigned int *)0xE0001000; //address of the register
    SCB_DEMCR    = (unsigned int *)0xE000EDFC; //address of the register
    *SCB_DEMCR   = *SCB_DEMCR | 0x01000000;
    *DWT_CYCCNT  = 0; // reset the counter
    *DWT_CONTROL = 0;
}

void start_timer(){
    *DWT_CONTROL = *DWT_CONTROL | 1 ; // enable the counter
}

void stop_timer(){
	*DWT_CONTROL = *DWT_CONTROL & 0xFFFFFFFE ; // disable the counter by clearing the enable bit
}

unsigned int getCycles(){
    return *DWT_CYCCNT;
}

/**
**===========================================================================
**
**  Abstract: main program
**
**===========================================================================
*/
//unsigned int myarreglo[20] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20};
//long int b[20] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20};

//unsigned int number_to_find = 20;

/*unsigned int myarreglo[20] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20};

void search(unsigned int arreglo[], unsigned int number_to_find)
	{
	  unsigned int i = 0;
	  while (i<20){
		  if (myarreglo[i] == number_to_find)
		  {
			  //printf("La posicion del arreglo es: %d \n",i);
			  return;
		  }
		  i++;
	  }
	  //printf("No se ha encontrado el numero buscado \n");
	  return;
	}


int main(void){
	unsigned int numCycles;

	reset_timer(); //reset timer
	start_timer(); //start timer
	search(myarreglo, 19);
	stop_timer(); //stop timer
	numCycles = getCycles(); //read number of cycles
	printf("numero de ciclos: %u \n", numCycles);
}
/*
unsigned int myarreglo[20]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20};
unsigned int number_to_find=1;
int main()
{
	unsigned int numCycles;
	reset_timer();
	start_timer();
    int i=0; //tratar de optimizar la memoria,
    //utilizandoo el ancho de la variable mas corta en este caso char
    int numero_encontrado=0;
    while(i<20){
        if(myarreglo[i]==number_to_find){
        	*DWT_CONTROL = *DWT_CONTROL & 0xFFFFFFFE ; // disable the counter by clearing the enable bit
        	numCycles = getCycles();
            //printf ("La posicion del arreglo es : %d \n",i);
            numero_encontrado=1;
        }
        i = i+1;
        //printf("la direccion de memoria ");
    }
    if(numero_encontrado==0){
        //printf("no se ha encontrado nada :) \n");
    }
    printf("numero de ciclos: %u \n", numCycles);
}
*/

int main(){
	unsigned int number,number2;
	unsigned int numCycles,numCycles2 ;
	reset_timer();
	start_timer();
	number=multiply_pow_2_v1 ( 2,32);
	stop_timer();
	numCycles = getCycles();

	reset_timer();
	start_timer();
	number2=multiply_pow_2_v2 (2,32);
	stop_timer();
	numCycles2 = getCycles();
	unsigned int a=0;
	printf("el numero mayor es %u \n",~a);
	printf("numero %u \n",number);
	printf("numero %u \n",number2);
	printf("ciclos1 %u \n",numCycles);
	printf("ciclos2 %u \n",numCycles2);
}

